# Basement Supercomputing tags
#Use as deafults if no command line inputs
%define releasebase 5 
%define as_limulus 1
# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}

%global systemd         1

#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_limulus}"
%define targetbase Limulus
%endif
%endif

%{!?_rel:%{expand:%%global _rel 0.r%(test "861" != "0000" && echo "861" || svnversion | sed 's/[^0-9].*$//' | grep '^[0-9][0-9]*$' || echo 0000)}}
%define debug_package %{nil}

Summary: Legacy Monitoring Package from Warewulf
Name: warewulf-monitor-legacy
Version: 2.9.90
Release:  %{releasebase}.%{targetbase}
#Release: %{_rel}
License: GPL
Group: System Environment/Clustering
URL: http://warewulf.lbl.gov/
Source: %{name}-%{version}.tar.gz
ExclusiveOS: linux
Requires: %{name}-common = %{version}-%{release}, gtemp
Prefix: %{_prefix}
BuildRoot: %{?_tmppath}%{!?_tmppath:/var/tmp}/%{name}-%{version}-%{release}-root
Patch0: warewulf-monitor-legacy.patch
Source1:            wulfd.service
Source2:            warewulfd.service
Patch1:             getstats.c.limulus-patch  
Patch2:             getstats.h.limulus-patch  
Patch3:             wulfd.c.limulus-patch
Patch4:             warewulfd.in.limulus-patch  
Patch5:             wwtop.in.limulus-patch


%description
Warewulf is a cluster management/monitoring toolset.

This package contains the warewulfd server daemon.


%package common
Summary: Files common to all warewulf packages
Group: System Environment/Clustering

%description common
Warewulf is a cluster management/monitoring toolset.

This package contains files needed by other warewulf subpackages.


%package tools
Summary: The Warewulf user tools
Group: System Enviornment/Clustering
Requires: %{name}-common = %{version}-%{release}

%description tools
Warewulf is a cluster management/monitoring toolset.

This subpackage includes the tools to communicate with the main
daemon or a proxy.


%package wulfd
Summary: The Warewulf node daemon
Group: System Enviornment/Daemons
Requires: chkconfig

%description wulfd
Warewulf is a cluster management/monitoring toolset.

This subpackage includes the node daemon that will communicate its
stats to the master node.


%package proxy
Summary: The Warewulf node daemon proxy service
Group: System Enviornment/Daemons
Requires: chkconfig
Requires: %{name}-common = %{version}-%{release}

%description proxy
Warewulf is a cluster management/monitoring toolset.

This subpackage provides support for aggregating multiple Warewulf
daemons together, or "relaying" the data to multiple login nodes.


%package web
Summary: The Warewulf web frontend
Group: System Enviornment/monitoring
Requires: httpd
Requires: %{name}-common = %{version}-%{release}

%description web
Warewulf is a cluster management/monitoring toolset.

This subpackage provides a web-based CGI/frontend to the Warewulf
daemon or proxy daemon.  It can monitor 1 or more clusters.


%prep
%setup -q
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0

%build
%configure
%{__make} %{?mflags}


%install
%{__make} install DESTDIR=$RPM_BUILD_ROOT %{?mflags_install}
# NOTE NOTE NOTE Updated for systemd start for wulfd and warewulf only DJE 01-AUG-2019
%if 0%{?systemd}
  install -Dp -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/wulfd.service
  install -Dp -m 0644 %{SOURCE2} %{buildroot}%{_unitdir}/warewulfd.service
# get rid of these files that install places automatically
  /bin/rm $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/warewulf
  /bin/rm $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/wulfd
%endif # systemd

%post
%if 0%{?systemd}
  systemctl enable warewulfd 
%else
  /sbin/chkconfig --add warewulf
  /sbin/chkconfig warewulf on
%endif


%post wulfd
%if 0%{?systemd}
  systemctl enable wulfd
%else
  /sbin/chkconfig --add wulfd
  /sbin/chkconfig wulfd on
%endif

%post web
/sbin/service httpd condrestart >/dev/null 2>&1 ||:
/sbin/service apache2 condrestart >/dev/null 2>&1 ||:
/usr/sbin/setsebool -P httpd_can_network_connect 1 >/dev/null 2>&1 ||:
chcon --reference=/var/www/html/ %{_datadir}/warewulf-legacy/web/cgi/* >/dev/null 2>&1 ||:

%post proxy
/sbin/chkconfig --add wwproxy
/sbin/chkconfig wwproxy on

%preun
if [ $1 -eq '0' ]; then
%if 0%{?systemd}
  systemctl --no-reload disable warewulfd.service
  systemctl stop warewulfd.service  
%else
   /sbin/service warewulf stop >/dev/null ||:
   /sbin/chkconfig --del warewulf
%endif
fi

%preun wulfd
if [ $1 -eq '0' ]; then
%if 0%{?systemd}
  systemctl --no-reload disable wulfd.service
  systemctl stop wulfd.service  
%else
   /sbin/service wulfd stop >/dev/null ||:
   /sbin/chkconfig --del wulfd
%endif
fi

%preun proxy
if [ $1 -eq '0' ]; then
   /sbin/service wwproxy stop >/dev/null ||:
   /sbin/chkconfig --del wwproxy
fi

%postun web
/sbin/service httpd condrestart >/dev/null 2>&1 ||:
/sbin/service apache2 condrestart >/dev/null 2>&1 ||:


%clean
#rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README TODO
%if 0%{?systemd}
  %{_unitdir}/warewulfd.service
%else
  %{_sysconfdir}/init.d/warewulf
%endif

%{_sbindir}/warewulfd

%files common
%defattr(-,root,root)
%{_prefix}/lib/warewulf-legacy

%files tools
%defattr(-,root,root)
%dir %{_sysconfdir}/warewulf-legacy
%config(noreplace) %{_sysconfdir}/warewulf-legacy/client.conf
%{_bindir}/wwnodes
%{_bindir}/wwstats
%{_bindir}/wwsummary
%{_bindir}/wwtop
%{_bindir}/wwmpirun
#%{_bindir}/wwps

%files wulfd
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/wulfd.conf
%if 0%{?systemd}
  %{_unitdir}/wulfd.service
%else
%{_sysconfdir}/init.d/wulfd
%endif
%{_sbindir}/wulfd

%files proxy
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/wwproxy.conf
%{_sysconfdir}/init.d/wwproxy
%{_sbindir}/wwproxy

%files web
%defattr(-,root,root)
%dir %{_datadir}/warewulf-legacy
%dir %{_datadir}/warewulf-legacy/web
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf
%{_datadir}/warewulf-legacy/web/cgi
%{_datadir}/warewulf-legacy/web/images

%changelog
* Thu Oct 22 2020 Douglas Eadline <deadline@basement-supercomputing.com>
- Updates for Limul wwtop: temperature display, one_pass option and some other tweeks
- changes are in *.limulus-patch files

